%%
%% This is file `pgcc.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% pgcc.dtx  (with options: `class')
%% 
%%
\def\filename{pgcc.dtx}
\def\fileversion{v2.0}
\def\filedate{2013/26/02}
\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{pgcc}[\filedate\ \fileversion\ PGCC Dissertations and Thesis]
\LoadClass[12pt,a4paper,oneside,final]{book}
\RequirePackage{lastpage}
\RequirePackage{hyperref}
\RequirePackage[english,brazil]{babel}
\RequirePackage{hyphenat}
\RequirePackage{ifthen}
\RequirePackage{graphicx}
\RequirePackage{tabularx}
\RequirePackage{eqparbox}

\RequirePackage[a4paper,bindingoffset=0.0cm,vcentering=true,
top=30mm,bottom=20mm,left=30mm,right=20mm]{geometry}
\def\pgccTeX{{\rm C\kern-.05em{\sc o\kern-.025em p\kern-.025em
p\kern-.025em e}}\kern-.08em\TeX}
\renewcommand\baselinestretch{1.5}
\let\@adname\@empty
\let\@adsurn\@empty
\let\@coadname\@empty
\let\@coadIIname\@empty
\let\@coadIIIname\@empty
\let\@coadsurn\@empty
\let\@examIname\@empty
\let\@examIIname\@empty
\let\@examIIIname\@empty


\newif\if@appendix\@appendixtrue

\newcounter{minexaminers}
\newboolean{isdraft}
\newboolean{maledoc}
\setboolean{maledoc}{false}
\setboolean{isdraft}{false}
\newboolean{needbb}
\setboolean{needbb}{false}
\DeclareOption{msc}{%
  \newcommand{\@degree}{M.Sc.}
  \newcommand{\@degreename}{Mestrado}
  \newcommand{\local@degname}{Mestre}
  \newcommand{\foreign@degname}{Master}
  \newcommand\local@doctype{Disserta{\c c}{\~ a}o}
  \newcommand\foreign@doctype{Dissertation}
  \setcounter{minexaminers}{2}
}
\DeclareOption{dscexam}{%
  \newcommand{\@degree}{D.Sc.}
  \newcommand{\@degreename}{Doutorado}
  \newcommand{\local@degname}{Doutor}
  \newcommand{\foreign@degname}{Doctor}
  \setboolean{maledoc}{true}
  \newcommand\local@doctype{Exame de Qualifica{\c c}{\~ a}o}
  \newcommand\foreign@doctype{Qualifying Exam}
  \setcounter{minexaminers}{1}
}
\DeclareOption{dsc}{%
  \newcommand{\@degree}{D.Sc.}
  \newcommand{\@degreename}{Doutorado}
  \newcommand{\local@degname}{Doutor}
  \newcommand{\foreign@degname}{Doctor}
  \newcommand\local@doctype{Tese}
  \newcommand\foreign@doctype{Thesis}
  \setcounter{minexaminers}{2}
}
\DeclareOption{draft}{%
  \setboolean{isdraft}{true}
  \ClassWarning{pgcc}{draft mode is ON}%
}
\DeclareOption{dvips}{%
  \PassOptionsToPackage{dvips}{hyperref,graphicx}
}
\DeclareOption{dvipdfm}{%
  \PassOptionsToPackage{dvipdfm}{hyperref,graphicx}
  \setboolean{needbb}{true}
}
\DeclareOption{pdftex}{%
  \PassOptionsToPackage{pdftex}{hyperref,graphicx}
  \PassOptionsToPackage{plainpages=false,pdfpagelabels}{hyperref}
}

\ProcessOptions\relax
\newcommand\university[1]{%
  \renewcommand\local@universityname{#1}
}
\newcommand\department[1]{%
  \ifthenelse{\equal{#1}{PGCC}}
    {\global\def\local@deptname{Ci\^encia da Computa\c c\~ao}
     \global\def\foreign@deptname{Computer Science}}{}
\ifthenelse{\equal{#1}{DCC}}
    {\global\def\local@deptname{Ci\^encia da Computa\c c\~ao}
     \global\def\foreign@deptname{Computer Science}}{}
}
\renewcommand\title[1]{%
  \global\def\local@title{#1}%
}
\newcommand\foreigntitle[1]{%
  \global\def\foreign@title{#1}%
}
\newcommand\advisor[5]{%
  \global\def\@adtitle{#1}%
  \global\def\@adname{#2}%
  \global\def\@adsurn{#3}%
  \global\def\@addegree{#4}%
  \global\def\@adinst{#5}%
}
\newcommand\coadvisor[5]{%
  \global\def\@coadtitle{#1}%
  \global\def\@coadname{#2}%
  \global\def\@coadsurn{#3}%
  \global\def\@coaddegree{#4}%
  \global\def\@coadinst{#5}%
  %\renewcommand\local@advisorstring{Orientadores}%
  %\renewcommand\foreign@advisorstring{Advisors}%
}

\newcommand\coadvisorII[5]{%
  \global\def\@coadIItitle{#1}%
  \global\def\@coadIIname{#2}%
  \global\def\@coadIIsurn{#3}%
  \global\def\@coadIIdegree{#4}%
  \global\def\@coadIIinst{#5}%
  %\renewcommand\local@advisorstring{Orientadores}%
  %\renewcommand\foreign@advisorstring{Advisors}%
}
\newcommand\examinerI[4]{%
  \global\def\@examItitle{#1}%
  \global\def\@examIname{#2}%
  \global\def\@examIdegree{#3}%
  \global\def\@examIinst{#4}%
}

\newcommand\examinerII[4]{%
  \global\def\@examIItitle{#1}%
  \global\def\@examIIname{#2}%
  \global\def\@examIIdegree{#3}%
  \global\def\@examIIinst{#4}%
}
\newcommand\examinerIII[4]{%
  \global\def\@examIIItitle{#1}%
  \global\def\@examIIIname{#2}%
  \global\def\@examIIIdegree{#3}%
  \global\def\@examIIIinst{#4}%
}

\newcount\@examiner\@examiner0
\newcommand\examiner[4]{%
  \global\@namedef{S:\expandafter\the\@examiner}{#1\ #3\ #2\linebreak #4}
  \global\advance\@examiner by 1
}
\renewcommand\author[2]{%
  \global\def\@authname{#1}
  \global\def\@authsurn{#2}
}
\renewcommand\date[3]{%
  \day=#1
  \month=#2
  \year=#3
}
\newcommand\local@monthname{\ifcase\month\or
  Janeiro\or Fevereiro\or Mar{\c c}o\or Abril\or Maio\or Junho\or
  Julho\or Agosto\or Setembro\or Outubro\or Novembro\or Dezembro\fi}
\newcommand\foreign@monthname{\ifcase\month\or
  January\or February\or March\or April\or May\or June\or
  July\or August\or September\or October\or November\or December\fi}
\newcommand\place[3]{%
  \renewcommand\local@cityname{#1}
  \renewcommand\local@statename{#2}
  \renewcommand\local@countryname{#3}
}
\newcounter{keywords}
\newcommand\keyword[1]{%
  \global\@namedef{K:\expandafter\the\c@keywords}{#1}
  \global\addtocounter{keywords}{1}
}
\newcounter{keywordsEN}
\newcommand\keywordEN[1]{%
  \global\@namedef{L:\expandafter\the\c@keywordsEN}{#1}
  \global\addtocounter{keywordsEN}{1}
}
\renewcommand\frontmatter{%
  \cleardoublepage
  \@mainmatterfalse
 \@appendixfalse
%   \pagenumbering{roman}
  \thispagestyle{empty}
  \setcounter{page}{2}
  \makefrontpage
  \clearpage
%   \pagestyle{plain}
%   \ifthenelse{\boolean{maledoc}}{}{}%
}


\renewcommand\mainmatter{%

  \immediate\write\@auxout{%
    \string\newlabel{front:pageno}{{}{\Roman{page}}{}{page.\roman{page}}{}}}
  \cleardoublepage
  \@mainmattertrue
\@appendixfalse
%   \pagestyle{plain}%numero da pagina no centro do rodape
%   \pagestyle{headings}%numero da pagina no cabecalho+titulo do capitulo
  \pagestyle{myheadings}%numero da pagina no cabecalho



%   \pagenumbering{arabic}


}


\renewcommand\backmatter{%
  \if@openright
    \cleardoublepage
  \else
    \clearpage
  \fi}


\newcommand\makecover{%
\pagestyle{empty}
\config@hypersetup
   \begin{center}
     \large
      UNIVERSIDADE FEDERAL DE JUIZ DE FORA \\
      INSTITUTO DE CINCIAS EXATAS\\
      P\'OS-GRADUA\c C\~AO EM CINCIA DA COMPUTAO \\
    \end{center}

\begin{center}
\vspace*{3.0cm}
\Large\nohyphens{\@authname\ \@authsurn}\par
\vspace*{3.0cm}
%   \nohyphens{\MakeUppercase\local@title}\par
\Large\nohyphens{\textbf{\local@title}}\par
\end{center}
  \Large
  \vspace*{\fill}
\begin{center}
  \frontpage@bottomtext
  \end{center}
  %\global\let\maketitle\relax%
  \global\let\and\relax
\setcounter{page}{1}
%\makecatalog
\normalsize

}






\renewcommand\maketitle{%
\pagestyle{empty}
% \pagenumbering{alph}
\config@hypersetup
  \begin{titlepage}
% \begin{flushleft}
% \setlength\baselineskip{0pt}
% \setlength\parskip{1mm}
% \makebox[70mm][c]{%
%  \ifthenelse{\boolean{needbb}}{%
%    \includegraphics[bb = 0 0 6 8]{PGCC-Logo-preto-256.png}
%   }{%
%   \includegraphics[width=6cm]{PGCC-Logo-preto-256.png}
% }}
%\end{flushleft}

   \begin{center}
     \normalsize
      UNIVERSIDADE FEDERAL DE JUIZ DE FORA \\
      INSTITUTO DE CINCIAS EXATAS\\
      P\'OS-GRADUA\c C\~AO EM CINCIA DA COMPUTAO \\
    \end{center}
  \vspace*{\fill}
\begin{center}
\large\nohyphens{\@authname\ \@authsurn}\par
%   \nohyphens{\MakeUppercase\local@title}\par
  \vspace*{\fill}
\Large\nohyphens{\textbf{\local@title}}\par
\end{center}
  \vspace*{\fill}
  \begin{flushright}
  \begin{minipage}{78mm}
    \frontcover@maintext
  \end{minipage}\par
  \end{flushright}
  \vspace*{\fill}
  \begin{flushleft}
   \begin{tabularx}{80mm}[b]{@{}l@{ }X@{}}
     \local@advisorstring: & \nohyphens{\@adname\ \@adsurn}\\
     \ifthenelse{\equal{\@coadname}{\@empty}}{}{%
     Coorientador: & \nohyphens{\@coadname\ \@coadsurn}\\}
     \ifthenelse{\equal{\@coadIIname}{\@empty}}{}{%
     Coorientador: & \nohyphens{\@coadIIname\ \@coadIIsurn}\\}
   \end{tabularx}\par
  \end{flushleft}
%  \begin{tabularx}{100mm}[b]{@{}l@{ }X@{}}
%   \local@advisorstring: & \nohyphens{\@adtitle\ \@addegree\ \@adname\ \@adsurn}\\
%   \ifthenelse{\equal{\@coadname}{\@empty}}{}{%
%   Coorientador: & \nohyphens{\@coadname\ \@coadsurn}\\}
 %   \ifthenelse{\equal{\@coadIIname}{\@empty}}{}{%
 %   Coorientador: & \nohyphens{\@coadIIname\ \@coadIIsurn}\\}
%  \end{tabularx}\par
  \vspace*{\fill}
  \begin{center}
%   \local@cityname\par
%   \local@monthname\ de \number\year
%   \number\year
  \large
  \frontpage@bottomtext
  \end{center}
  \end{titlepage}
  \global\let\maketitle\relax%
  \global\let\and\relax


\setcounter{page}{1}
%\makecatalog

}








\newcommand\makefrontpage{%
  \begin{center}
  \nohyphens{\@authname\ \@authsurn}\par
    \vspace*{\fill}
%   \nohyphens{\MakeUppercase\local@title}\par
\large\nohyphens{\textbf{\local@title}}\par
  \end{center}
  \vspace*{\fill}
  \begin{flushright}
  \begin{minipage}{78mm}
  \frontcover@maintext
  \end{minipage}\par
  \end{flushright}
   \vspace*{\fill}

%   \begin{center}
%     \sloppy\nohyphens{\MakeUppercase\local@title}\par
%     \vspace*{7mm}
%     {\@authname\ \@authsurn}\par
%   \end{center}\par
%   \vspace*{4mm}
%   \frontpage@maintext
%   \vspace*{8mm}


  \noindent\local@approvedname \ \number\day \ de \local@monthname \ de \number\year.\par


     \begin{center}

BANCA EXAMINADORA
%   \begin{flushright}
	\baselineskip14pt
        \vskip40\p@ 
        \eqmakebox[signture@list]{\hrulefill}\\
        \eqmakebox[signture@list]{
          \ \ \ \@adtitle\ \@addegree\ \@adname\ \@adsurn\ -\ Orientador\ \ \ } \\ 
        \eqmakebox[signture@list]{
          \ \ \ \@adinst\ \ \ } \\ 

        \ifthenelse{\equal{\@coadname}{\@empty}}{}{%
        \vskip40\p@ %\baselineskip12pt
        \eqmakebox[signture@list]{\hrulefill}\\
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@coadtitle\ \@coaddegree\ \@coadname\ \@coadsurn\ -\ Coorientador\ \ \ }\\ 
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@coadinst \ \ \ }
\\}

	\ifthenelse{\equal{\@coadIIname}{\@empty}}{}{%
        \vskip40\p@ %\baselineskip12pt
        \eqmakebox[signture@list]{\hrulefill}\\
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@coadIItitle\ \@coadIIdegree\ \@coadIIname\ \@coadIIsurn\ -\ Coorientador \ \ \ } \\ 
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@coadIIinst \ \ \ }
\\}

        \ifthenelse{\equal{\@examIname}{\@empty}}{}{%
        \vskip40\p@ %\baselineskip12pt
        \eqmakebox[signture@list]{\hrulefill}\\
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@examItitle\ \@examIdegree\ \@examIname\ \ \ }\\ 
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@examIinst \ \ \ }
\\}

        \ifthenelse{\equal{\@examIIname}{\@empty}}{}{%
        \vskip40\p@ %\baselineskip12pt
        \eqmakebox[signture@list]{\hrulefill}\\
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@examIItitle\ \@examIIdegree\ \@examIIname\ \ \ }\\ 
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@examIIinst \ \ \ }
\\}

        \ifthenelse{\equal{\@examIIIname}{\@empty}}{}{%
        \vskip40\p@ %\baselineskip12pt
        \eqmakebox[signture@list]{\hrulefill}\\
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@examIIItitle\ \@examIIIdegree\ \@examIIIname\ \ \ }\\ 
        \eqmakebox[signture@list]{%\protect\centering%
          \ \ \ \@examIIIinst \ \ \ }
\\}

%         \count1=0
%         \@whilenum \count1<\@examiner \do {
%             \vskip40\p@ \baselineskip12pt
%         \eqmakebox[signture@list]{\hrulefill}\\
%         \eqmakebox[signture@list]{\protect\centering%
%             \baselineskip18pt\ \ \ \csname S:\the\count1 \endcsname\ \ \ }\\
%             \advance\count1 by 1}



%   \end{flushright}

     \end{center}
%   \vspace*{\fill}
%   \frontpage@bottomtext
}  %end fontpage

\newcommand\config@hypersetup{%
\begingroup
  % changes to \toks@ and \count@ are kept local;
  % it's not necessary for them, but it is usually the case
  % for \count1, because the first ten counters are written
  % to the DVI file, thus you got lucky because of PDF output
  \toks@={}% in this special case not necessary
  \count@=0 %
  \@whilenum\count@<\value{keywords}\do{%
    % * a keyword separator is not necessary,
    %    if there is just one keyword
    % * \csname K:\the\count@\endcsname must be expanded
    %    at least once, to get rid of the loop depended \count@
    \ifcase\count@ % same as \ifnum0=\count@
      \toks@=\expandafter{\csname K:\the\count@\endcsname}%
    \else
      \toks@=\expandafter\expandafter\expandafter{%
        \expandafter\the\expandafter\toks@
        \expandafter;\expandafter\space
        \csname K:\the\count@\endcsname
      }%
    \fi
    \advance\count@ by 1 %
  }%
  \edef\x{\endgroup
    \noexpand\hypersetup{%
      pdfkeywords={\the\toks@}%
    }%
  }%
\x
\hypersetup{%
  pdfauthor={\@authname\ \@authsurn},
  pdftitle={\local@title},
  pdfsubject={\local@doctype\ de \@degreename\ em \local@deptname\ do PGCC/DCC/UFJF},
  pdfcreator={},
  breaklinks={true},
  raiselinks={true},
  pageanchor={true},
}}
\newcommand\makecatalog{%
  \pagestyle{empty}
  \vspace*{\fill}
  \begin{center}
    \setlength{\fboxsep}{5mm}
    \framebox[120mm][c]{\makebox[5mm][c]{}%
      \begin{minipage}[c]{105mm}
      \setlength{\parindent}{5mm}
      \noindent\sloppy\nohyphens\@authsurn,
      \nohyphens\@authname\par
      \nohyphens{\local@title/\@authname\ \@authsurn. -- \local@cityname:
      UFJF/DCC, \number\year.}\par
      \pageref{front:pageno},
      \pageref{LastPage}
      p.\@ifundefined{r@cat:lofflag}{}{\pageref{cat:lofflag}} $29,7$cm.\par
      % There is an issue here. When the last entry must be split between lines,
      % the spacing between it and the next paragraph becomes smaller.
      % Should we manually introduce a fixed space? But how could we know that
      % a name was split?
      \begin{tabularx}{100mm}[b]{@{}l@{ }X@{}}
            \local@advisorstring: & \nohyphens{\@adname\ \@adsurn}\\
	    \ifthenelse{\equal{\@coadname}{\@empty}}{}{%
	    Coorientadora: & \nohyphens{\@coadname\ \@coadsurn}\\}
	    \ifthenelse{\equal{\@coadIIname}{\@empty}}{}{%
	    Coorientadora: & \nohyphens{\@coadIIname\ \@coadIIsurn}\\}
      \end{tabularx}\par
      \nohyphens{\local@doctype\ ({\MakeLowercase\@degreename}) --
      UFJF/DCC/Programa de Ps-Graduao em \local@deptname, \number\year.}\par
      \bibname: p. \pageref{bib:begin} -- \pageref{bib:end}.\par
      \count1=0
      \count2=1
      \nohyphens{\@whilenum \count1<\value{keywords} \do {%
        \number\count2. \csname K:\the\count1 \endcsname.
        \advance\count1 by 1
        \advance\count2 by 1}
      I. \@adsurn, \@adname%
      \ifthenelse{\equal{\@coadname}{\@empty}}{}{\emph{~et~al.}}.
      II. \local@universityname, DCC, Programa de Ps-Graduao em \local@deptname.}
    \end{minipage}}
  \end{center}
  \vspace*{\fill}}
\newcommand\dedication[1]{
  \gdef\@dedic{#1}
    \cleardoublepage
    \vspace*{\fill}
    \begin{flushright}
      \begin{minipage}{60mm}
        \raggedleft \it \normalsize \@dedic
      \end{minipage}
    \end{flushright}}

\newcommand\epigrafe[1]{
  \gdef\@dedic{#1}
    \cleardoublepage
    \vspace*{\fill}
    \begin{flushright}
      \begin{minipage}{60mm}
        \raggedleft \it \normalsize \@dedic
      \end{minipage}
    \end{flushright}}


\renewcommand\tableofcontents{%
\clearpage
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
%     \section*{\centering\MakeUppercase\contentsname
%         \@mkboth{%
%            \MakeUppercase\contentsname}{\MakeUppercase\contentsname}}%
    {\begin{center}\Large\textbf{\MakeUppercase{\contentsname}}\end{center}
        \@mkboth{%
           \MakeUppercase\contentsname}{\MakeUppercase\contentsname}}\vspace*{1.cm}%
    \@starttoc{toc}%
    \if@restonecol\twocolumn\fi
    }


% \setcounter{secnumdepth}{2}
\setcounter{secnumdepth}{3}  %para numerar ate subsubsection



\renewcommand*\l@part[2]{%
  \ifnum \c@tocdepth >-2\relax
    \addpenalty{-\@highpenalty}%
    \addvspace{2.25em \@plus\p@}%
    \setlength\@tempdima{3em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      {\leavevmode
       \Large \bfseries #1\hfil \hb@xt@\@pnumwidth{\hss #2}}\par
       \nobreak
         \global\@nobreaktrue
         \everypar{\global\@nobreakfalse\everypar{}}%
    \endgroup
  \fi}
\renewcommand*\l@chapter[2]{%
  \ifnum \c@tocdepth >\m@ne
    \addpenalty{-\@highpenalty}%
    \vskip 1.0em \@plus\p@
    \setlength\@tempdima{1.5em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      \leavevmode \bfseries 
      \advance\leftskip\@tempdima 
      \hskip -\leftskip
      #1\nobreak\hfil \dotfill\nobreak\hb@xt@\@pnumwidth{\hss #2}\par
      \penalty\@highpenalty
    \endgroup
  \fi}

\renewcommand*\l@section[2]{%
  \ifnum \c@tocdepth >\m@ne
%     \addpenalty{-\@highpenalty}%
%     \vskip 1.0em \@plus\p@
    \setlength\@tempdima{1.5cm}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      \leavevmode 
      \advance\leftskip\@tempdima 
      \hskip -\leftskip 
      {#1} \nobreak\hfil \dotfill\nobreak\hb@xt@\@pnumwidth{\scshape\hss #2}\par
      \penalty\@highpenalty
    \endgroup
  \fi}


\renewcommand*\l@subsection[2]{%
  \ifnum \c@tocdepth >\m@ne
%     \addpenalty{-\@highpenalty}%
%     \vskip 1.0em \@plus\p@
    \setlength\@tempdima{3.5em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      \leavevmode 
      \advance\leftskip\@tempdima 
      \hskip -\leftskip
      #1\nobreak\hfil \dotfill\nobreak\hb@xt@\@pnumwidth{\scshape\hss #2}\par
      \penalty\@highpenalty
    \endgroup
  \fi}


\renewcommand*\l@subsubsection[2]{%
  \ifnum \c@tocdepth >\m@ne
%     \addpenalty{-\@highpenalty}%
%     \vskip 1.0em \@plus\p@
    \setlength\@tempdima{4.1em}%
    \begingroup
      \parindent \z@ \rightskip \@pnumwidth
      \parfillskip -\@pnumwidth
      \leavevmode \mdseries
      \advance\leftskip\@tempdima 
      \hskip -\leftskip
      #1\nobreak\hfil \dotfill\nobreak\hb@xt@\@pnumwidth{\scshape\hss #2}\par
      \penalty\@highpenalty
    \endgroup
  \fi}


% \renewcommand*\l@section{\bfseries\@dottedtocline{1}{0em}{2.3em}}
% \renewcommand*\l@subsection{\@dottedtocline{2}{0em}{3.2em}}
% \renewcommand*\l@subsubsection{\@dottedtocline{3}{0em}{4.1em}}
\renewcommand*\l@paragraph{\@dottedtocline{4}{0em}{5em}}
\renewcommand*\l@subparagraph{\@dottedtocline{5}{0em}{6em}}



\renewcommand\chapter{\if@openright\cleardoublepage\else\clearpage\fi
%                     \thispagestyle{plain}%
                    \global\@topnum\z@
                    \@afterindentfalse
                    \secdef\@chapter\@schapter}
\def\@chapter[#1]#2{\ifnum \c@secnumdepth >\m@ne
		    

                       \if@mainmatter
                         \refstepcounter{chapter}%
                         \typeout{\@chapapp\space\thechapter.}%

			  \if@appendix
% 			      \addcontentsline{toc}{chapter}% NAO COLOCA NO SUMARIO OS CAPITULOS DO APENDICE
%                                  {\protect\numberline{\thechapter}ddd#1}%
			  \else
				\addcontentsline{toc}{chapter}%
                                   {\protect\numberline{\thechapter} \uppercase{#1}}%
			  \fi

%                          \addcontentsline{toc}{chapter}%
%                                    {\protect\numberline{\thechapter}#1}%
                       \else
			  
				\addcontentsline{toc}{chapter}{\uppercase{#1}}%
                       \fi
                    \else
                      \addcontentsline{toc}{chapter}{\uppercase{#1}}%
                    \fi
                    \chaptermark{#1}%
                    \addtocontents{lof}{\protect\addvspace{10\p@}}%
                    \addtocontents{lot}{\protect\addvspace{10\p@}}%
                    \if@twocolumn
                      \@topnewpage[\@makechapterhead{#2}]%
                    \else
                      \@makechapterhead{#2}%
                      \@afterheading
                    \fi}
\def\@makechapterhead#1{%
%   \vspace*{50\p@}%
  {\parindent \z@ \raggedright \normalfont
    \ifnum \c@secnumdepth >\m@ne
      \if@mainmatter
%         \huge\bfseries \@chapapp\space \thechapter
%         \Huge\bfseries \thechapter

        \par\nobreak
        \vskip 20\p@
      \fi
    \fi
    \interlinepenalty\@M

    \if@appendix
	 \bfseries \Large \appendixname \space  \thechapter \space - \space \uppercase{#1}\par\nobreak
    \else
	\Large \bfseries \thechapter \space \space \uppercase{#1}\par\nobreak
    \fi

    \vskip 40\p@
  }}
\def\@schapter#1{\if@twocolumn
                   \@topnewpage[\@makeschapterhead{#1}]%
                 \else
                   \@makeschapterhead{#1}%
                   \@afterheading
                 \fi}
\def\@makeschapterhead#1{%
  \vspace*{50\p@}%
  {\parindent \z@ \raggedright
    \normalfont
    \interlinepenalty\@M
    \Huge \bfseries \MakeUppercase #1\par\nobreak
    \vskip 40\p@
  }}

\renewcommand\section{\@startsection {section}{1}{\z@}%
                                   {-3.5ex \@plus -1ex \@minus -.2ex}%
                                   {2.3ex \@plus.2ex}%
                                   {\normalfont\large\MakeUppercase}}
\renewcommand\subsection{\@startsection{subsection}{2}{\z@}%
                                     {-3.25ex\@plus -1ex \@minus -.2ex}%
                                     {1.5ex \@plus .2ex}%
                                     {\normalfont\large\MakeUppercase}}
\renewcommand\subsubsection{\@startsection{subsubsection}{3}{\z@}%
                                     {-3.25ex\@plus -1ex \@minus -.2ex}%
                                     {1.5ex \@plus .2ex}%
                                     {\normalfont\large}}


\newenvironment{agradecimentos}{%
  \clearpage
  %\thispagestyle{plain}
  \pagestyle{empty}
\begin{center}
\Large\textbf{AGRADECIMENTOS}
\end{center}
\vspace*{1.cm}
\par
% \begin{center}
%  \section*{\centering AGRADECIMENTOS}
% \end{center}
}



\newenvironment{resumo}{%
  \clearpage
  %\thispagestyle{plain}
  \pagestyle{empty}
  {\Large\resumo@toptext}
  \vspace*{1.5cm}
}
{
\vspace*{1.5cm}
\par\textbf{Palavras-chave:} \count1=0 \nohyphens{\@whilenum \count1<\value{keywords} \do 
{      \csname K:\the\count1 \endcsname. 
        \advance\count1 by 1}}

\vspace*{\fill}
}


\newenvironment{abstract}{%
  \clearpage
  %\thispagestyle{plain}
  \pagestyle{empty}
  {\Large\abstract@toptext}
  \vspace*{1.5cm}
}
{
\vspace*{1.5cm} 
\par\textbf{Keywords:} \count1=0 \nohyphens{\@whilenum \count1<\value{keywordsEN} \do 
{      \csname L:\the\count1 \endcsname.
        \advance\count1 by 1}}

\vspace*{\fill}
}



\newenvironment{simbolos}{%
  \clearpage
  %\thispagestyle{plain}
  \pagestyle{empty}
  \flushleft
  \begin{center}\Large\bf LISTA DE S\'IMBOLOS\\\end{center}
  \vspace*{2cm}
}
{
\vspace*{\fill}
\clearpage
}



\renewcommand\listoffigures{%
\clearpage
  \pagestyle{empty}
  \immediate\write\@auxout{%
  \string\newlabel{cat:lofflag}{{}{:~il.;}{}{page.\roman{page}}{}}}
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
%     \chapter*{\listfigurename}%
% \section*{\centering\MakeUppercase\listfigurename}
    \begin{center}\Large\textbf{\MakeUppercase{Lista de figuras}}\end{center}
%       \addcontentsline{toc}{chapter}{\listfigurename}%
      \@mkboth{\MakeUppercase\listfigurename}%
              {\MakeUppercase\listfigurename}
\vspace*{1.cm}%
    \@starttoc{lof}%
    \if@restonecol\twocolumn\fi
    }


\renewcommand\listoftables{%
\clearpage
\pagestyle{empty}
    \if@twocolumn
      \@restonecoltrue\onecolumn
    \else
      \@restonecolfalse
    \fi
%     \chapter*{\listtablename}%
% \section*{\centering\MakeUppercase\listtablename}
    \begin{center}\Large\textbf{\MakeUppercase{\listtablename}}\end{center}
%       \addcontentsline{toc}{chapter}{\listtablename}%
      \@mkboth{%
          \MakeUppercase\listtablename}%
         {\MakeUppercase\listtablename}%
\vspace*{1.cm}
    \@starttoc{lot}%
    \if@restonecol\twocolumn\fi
    }


\newcommand\printlosymbols{%
\renewcommand\glossaryname{\listsymbolname}%
%\@input@{\jobname.los}}
\@input@{\jobname.syx}}

\def\makelosymbols{%
  \newwrite\@losfile
  \immediate\openout\@losfile=\jobname.syx
  \def\symbl{\@bsphack\begingroup
             \@sanitize
             \@wrlos}\typeout
  {Writing index of symbols file \jobname.syx}%
  \let\makelosymbols\@empty
}
\@onlypreamble\makelosymbols
\AtBeginDocument{%
\@ifpackageloaded{hyperref}{%
  \def\@wrlos#1#2{%
    \protected@write\@losfile{}%
      {\string\indexentry{[#1] #2|hyperpage}{\thepage}}%
    \endgroup
    \@esphack}}{%
  \def\@wrlos#1#2{%
    \protected@write\@losfile{}%
      {\string\indexentry{[#1] #2}{\thepage}}%
    \endgroup
    \@esphack}}}


\newcommand\printloabbreviations{%
\renewcommand\glossaryname{\listabbreviationname}%
\@input@{\jobname.lab}}
\def\makeloabbreviations{%
  \newwrite\@labfile
  \immediate\openout\@labfile=\jobname.abx
  \def\abbrev{\@bsphack\begingroup
              \@sanitize
              \@wrlab}\typeout
  {Writing index of abbreviations file \jobname.abx}%
  \let\makeloabbreviations\@empty
}
\@onlypreamble\makeloabbreviations
\AtBeginDocument{%
\@ifpackageloaded{hyperref}{%
  \def\@wrlab#1#2{%
    \protected@write\@labfile{}%
      {\string\indexentry{[#1] #2|hyperpage}{\thepage}}%
    \endgroup
    \@esphack}}{%
  \def\@wrlab#1#2{%
    \protected@write\@labfile{}%
      {\string\indexentry{[#1] #2}{\arabic{page}}}%
    \endgroup
    \@esphack}}}
\newdimen\bibindent%
\setlength\bibindent{0em}%

\renewenvironment{thebibliography}[1]%
     {
% 	\chapter*{Refer\^encias}%
% \section*{\centering REFER\^ENCIAS}
   \begin{center}\Large\textbf{\MakeUppercase{REFER\^ENCIAS}}\end{center}
    \vspace{1.0cm}
%     	\begin{center}
% 		\section*{Refer\^encias}
% 	\end{center}%
%       \addcontentsline{toc}{chapter}{\bibname}%
      \addcontentsline{toc}{chapter}{REFER\^ENCIAS}%
      \immediate\write\@auxout{%
      \string\newlabel{bib:begin}{{}{\arabic{page}}{}{page.\arabic{page}}{}}}%
      \list{\@biblabel{\@arabic\c@enumiv}}%
           {\setlength{\labelwidth}{0ex}%
            \setlength{\leftmargin}{1.0ex}%
            \setlength{\itemindent}{-1.0ex}%
            \advance\leftmargin\labelsep%
            \@openbib@code%
            \usecounter{enumiv}%
            \let\p@enumiv\@empty%
            \renewcommand\theenumiv{\@arabic\c@enumiv}}%
      \sloppy%
      \clubpenalty4000%
      \@clubpenalty \clubpenalty%
      \widowpenalty4000%
      \sfcode`\.\@m}%
     {\def\@noitemerr%
       {\@latex@warning{Empty `thebibliography' environment}}%
      \immediate\write\@auxout{%
      \string\newlabel{bib:end}{{}{\arabic{page}}{}{page.\arabic{page}}{}}}%
      \endlist}


\renewcommand\appendix{
% \clearpage
\@appendixtrue
\addcontentsline{toc}{chapter}{AP\^ENDICES}%
  \setcounter{chapter}{0}%
  \setcounter{section}{0}%
  \gdef\@chapapp{\appendixname}%
  \gdef\thechapter{\@Alph\c@chapter}
}



\newenvironment{theglossary}{%
  \if@twocolumn%
    \@restonecoltrue\onecolumn%
  \else%
    \@restonecolfalse%
  \fi%
  \@mkboth{\large\MakeUppercase\glossaryname}%
  {\Large\MakeUppercase\glossaryname}%
%   \chapter*{\glossaryname}%
% \section*{\centering\MakeUppercase\glossaryname}
   \begin{center}\Large\textbf{\MakeUppercase{\glossaryname}}\end{center}
%   \addcontentsline{toc}{chapter}{\glossaryname}
  \list{}
  {\setlength{\listparindent}{0in}%
   \setlength{\labelwidth}{1.0in}%
   \setlength{\leftmargin}{1.5in}%
   \setlength{\labelsep}{0.5in}%
   \setlength{\itemindent}{0in}}%
   \sloppy}%
  {\if@restonecol\twocolumn\fi%
\endlist}
\renewenvironment{theindex}{%
  \if@twocolumn
    \@restonecolfalse
  \else
    \@restonecoltrue
  \fi
  \twocolumn[\@makeschapterhead{\indexname}]%
  \@mkboth{\MakeUppercase\indexname}%
  {\MakeUppercase\indexname}%
  \thispagestyle{plain}\parindent\z@
%   \addcontentsline{toc}{chapter}{\indexname}
  \parskip\z@ \@plus .3\p@\relax
  \columnseprule \z@
  \columnsep 35\p@
  \let\item\@idxitem}
  {\if@restonecol\onecolumn\else\clearpage\fi}

\renewcommand\appendixname{Ap\^endice}
\newcommand\glossaryname{Gloss\'ario}
\newcommand\listabbreviationname{Lista de Abreviaturas e Siglas}
\renewcommand\listfigurename{Lista de Figuras}
\newcommand\listsymbolname{Lista de S{\' i}mbolos}
\newcommand\local@advisorstring{Orientador}
\newcommand\foreign@advisorstring{Advisor}
\ifthenelse{\boolean{maledoc}}{%
%   \newcommand\local@approvedname{Aprovado por}%
  \newcommand\local@approvedname{Aprovado em}%
}{%
%   \newcommand\local@approvedname{Aprovada por}%
  \newcommand\local@approvedname{Aprovada em}%
}
\newcommand\foreign@approvedname{Approved by}
\newcommand\local@universityname{Universidade Federal de Juiz de Fora}
\newcommand\local@deptstring{Programa}
\newcommand\foreign@deptstring{Department}
\newcommand\local@cityname{Juiz de Fora}
\newcommand\local@statename{MG}
\newcommand\local@countryname{Brasil}
\newcommand\frontcover@maintext{
%   \sloppy\nohyphens{\local@doctype\ de \@degreename\
   \baselineskip14pt\sloppy\nohyphens{\local@doctype\
  \ifthenelse{\boolean{maledoc}}{apresentado}{apresentada}
  ao Programa de P{\' o}s-Gradua{\c c}{\~ a}o em \local@deptname, do 
Instituto de Cincias Exatas da \local@universityname\ como requisito parcial
  para obten{\c c}{\~ a}o do ttulo de
  \local@degname\ em \local@deptname.}
}

\newcommand\frontpage@maintext{
  \noindent {\MakeUppercase\local@doctype}
  \ifthenelse{\boolean{maledoc}}{APRESENTADO}{APRESENTADA}
  \sloppy\nohyphens{AO PROGRAMA DE P{\' O}S-GRADUA{\c C}{\~ A}O EM CINCIA DA COMPUTAO DA
  UNIVERSIDADE FEDERAL DE JUIZ DE FORA COMO REQUISITO PARCIAL
  PARA OBTEN{\c C}{\~ A}O DO GRAU DE  {\MakeUppercase\local@degname} EM }
  {\MakeUppercase\local@deptname. \par}%
}
\newcommand\frontpage@bottomtext{%
  \begin{center}
%   {\MakeUppercase{\local@cityname, \local@statename\ -- \local@countryname}}\par
%   {\MakeUppercase\local@monthname\ DE \number\year}
  \local@cityname\par
  \number\year
  \end{center}%
}
\newcommand\resumo@toptext{%
% \chapter*{Resumo}
% \section*{\centering RESUMO}
\begin{center}\textbf{RESUMO} \end{center}
%   \noindent Resumo \ifthenelse{\boolean{maledoc}}{do}{da}
%   \local@doctype\ \ifthenelse{\boolean{maledoc}}{apresentado}{apresentada}
%   \sloppy\nohyphens{{\` a} UFJF como parte dos requisitos
%   necess{\' a}rios para a obten{\c c}{\~ a}o do grau de
%   \local@degname\ em Ci{\^ e}ncias (\@degree)}
}
\newcommand\abstract@toptext{%
% \chapter*{Abstract}
% \section*{\centering ABSTRACT}
\begin{center}\textbf{ABSTRACT} \end{center}
%   \noindent \sloppy\nohyphens{Abstract of \foreign@doctype\ presented to
%   UFJF as a partial fulfillment of the requirements for the
%   degree of \foreign@degname\ of Science (\@degree)}
}

\makeatletter
\AtBeginDocument{
\makeatletter
\@ifpackageloaded{natbib} {
  % Se usa natbib

\def\cite{\citep}        %% PARA NATBIB: PADRO PARA \cite  \citep


\makeatletter
\def\oldcitetstar*{%
   \@ifnextchar[%
     {\oldcitetstar@i}
     {\oldcitet}%
}
\def\oldcitetstar@i[#1]{%
     \oldcitet[#1]
}
\makeatother

\let\oldcitet\citet        % Keep "old" definition of \citet
\def\citet{\@ifnextchar*{\oldcitetstar}{\oldcitet*}}   %% PARA NATBIB: PADRO PARA \citet  \citet*


 \renewcommand\bibsection{%
   \clearpage
   \pagestyle{empty}
   \begin{center}\Large\textbf{\MakeUppercase{REFER\^ENCIAS}}\end{center}
    \addcontentsline{toc}{chapter}{REFER\^ENCIAS}%
    \vspace{1.0cm}
  }
  \setlength{\bibhang}{1.0ex}


}{
% Usado para decidir a forma de apresentacao da citacao.
\newif\if@citet
\@citetfalse

 % Se nao usa natbib
\renewcommand{\@cite}[2] {
\if@citet
{{#1\ifthenelse{\equal{#2}{}}{}{,{\optionaltextstyle#2}}}}
\else
{({#1\ifthenelse{\equal{#2}{}}{}{,{\optionaltextstyle#2}}})}
\fi
}
%    {({#1\ifthenelse{\equal{#2}{}}{}{,
 %         {\optionaltextstyle#2}}})}

\newcommand\citeauthoryear[3]{\if@citet#1 (#3)\else#2, #3\fi}

\makeatletter\def\@biblabel#1{}

\makeatletter
\def\@citex[#1]#2{%
  \let\@citea\@empty
  \@cite{\@for\@citeb:=#2\do
    {\@citea\def\@citea{;\penalty\@m\ }%
     \edef\@citeb{\expandafter\@firstofone\@citeb}%
     \if@filesw\immediate\write\@auxout{\string\citation{\@citeb}}\fi
     \@ifundefined{b@\@citeb}{\mbox{\reset@font\bfseries ?}%
       \G@refundefinedtrue
       \@latex@warning
         {Citation `\@citeb' on page \thepage \space undefined}}%
       {\csname b@\@citeb\endcsname}}}{#1}}
\makeatother


\makeatletter
\def\citestar*{%
   \@ifnextchar[%
     {\citestar@i}
     {\cite}%
}
\def\citestar@i[#1]{%
     \cite
}

\def\citet{%
  \@citettrue
   \@ifnextchar*
   {\citestar}{
     \@ifnextchar[%
     {\citestar@i}
     {\cite}%
  }
}

\def\citep{%
  \@citetfalse
   \@ifnextchar*
   {\citestar}{
     \@ifnextchar[%
     {\citestar@i}
     {\cite}%
  }
}

\makeatother

}
}


\let\oldsection\section% Keep "old" definition of \section
\def\oldname@@{\uppercase}
\makeatletter
\renewcommand{\section}[2][]{% First letter capatalized and end in period.
\oldsection{\oldname@@{#2}}
%  \@ifmtarg{#1}%
 %   {\oldsection{\uppercase{#2}}}% \section[..]{...}
%    {\oldsection[#1]{\uppercase{#1}}}% \section{...}
}
\makeatother
  


%% 
%%
%% End of file `pgcc.cls'.
